var REDIRECT_URL = "/bonuses.html"; // the URL to redirect the user to

var resultObj		= null;	// the result object from the php file
var hasFilledInForm	= false;// have we filled in our form details?
var hasGottenResult	= false;// have we gotten our results yet?

// fills in the hidden form with the name and email from the form the user filled out
function setDetails( name, email )
{
	// create our object
	var replaceObj = {
		'EMAIL':email,
		'FNAME':name
	}
	
	// go down through our hidden form and replace the values
	var $parent = document.getElementById( 'hidden-form' );
	fillForm( $parent, replaceObj );
	
	// check if we can finish (async nature of web)
	hasFilledInForm = true;
	handleResult();
}

// sets the result from searching to see if they're signed up or not
function setResult( result )
{
	resultObj = result;
	
	// check if we can finish (async nature of web)
	hasGottenResult = true;
	handleResult();
}

// recursive function to fill a form with the necessary details
function fillForm( parent, replaceObj )
{
	// failsafe
	if( !parent )
		return;
	
	var children 	= parent.children;
	var len			= children.length;
	for( var i = 0; i < len; i++ )
	{
		var nodeName = children[i].nodeName;
		if( nodeName == 'INPUT' )
		{
			// get the name of this element and see does it match one of our keys
			if( children[i].name in replaceObj )
				children[i].value = replaceObj[children[i].name];
		}
		else if( nodeName == 'DIV' || nodeName == 'FORM' )
			fillForm( children[i], replaceObj );
	}
}

// checks if we can show the result to the user
function handleResult()
{
	if( !hasFilledInForm || !hasGottenResult )
		return;
	
	// depending on the result data returned, it either worked or it didn't work, so either
	// submit the form normally, or redirect the page
	var success	= ( resultObj != null ) ? resultObj.success : false;
	var status	= ( resultObj != null ) ? resultObj.status : null;
	var email	= ( resultObj != null ) ? resultObj.email_address : null;
	
	// if it didn't work, just submit the form normally (they'll get the url in the email)
	if( !success )
	{
		// NOTE: we could also redirect the original page if necessary (if we're not doing it
		// through a mail)
//		window.opener.location.href = REDIRECT_URL;
		submitManually();
		return;
	}
	
	// if their status is pending, then show up a warning reminder
	if( status == 'pending' )
	{
		var html = "<div class=\"warning-reminder\"><h2>Action required</h2><p>You still need to confirm your subscription.</p><p>To confirm, simply click on the link in the opt-in email that was sent to <strong>" + email + "</strong>. If you can't find it, check your Spam folder in case it's gone in there.</p><p>If you've any problems, get in touch.</p></div>";
		if( REDIRECT_URL != null )
			html += "<a href=\"" + REDIRECT_URL + "\" class=\"form-button\">Get my content</a>";
		
		// replace our content
		var $el 		= document.getElementById( 'signup-div' );
		$el.innerHTML 	= html;
		return;
	}
	
	// it worked, so just redirect them to our content
	if( REDIRECT_URL != null )
	{
		window.setTimeout( function() {
			window.location.href = REDIRECT_URL;
		}, 500 );
	}
	else
		console.warn( "We don't have a redirect url" );
}

// submits the form manually
function submitManually(e)
{
	if( e )
		e.preventDefault();
	
	// get our parent div and find the form
	var $form = document.getElementById( 'hidden-form' );
	$form.submit();
}